/**
 * @notice Gets transaction info with a GraphQL query
 * @param chainId The chainId to query for. Optional.
 * @param address The address to query for. Optional.
 * @param txnHash The transaction hash to query for. Optional.
 * @param kappa The kappa to query for. Optional.
 * @returns A promise that resolves to the transaction info as a JSON object
 */
export declare function getBridgeTxnInfo(args: {
    chainId?: number;
    address?: string;
    txnHash?: string;
    kappa?: string;
}): Promise<JSON>;
