import type { ChainIdTypeMap } from "../common/chainid";
import type { StringMap } from "../common/types";
import type { Provider } from "@ethersproject/providers";
import { Web3Provider } from "@ethersproject/providers";
import { MiniRpcProvider } from "./minirpc";
interface RpcConnectorArgs {
    urls: StringMap;
    batchInterval?: number;
}
export declare class RpcConnector {
    protected _providers: ChainIdTypeMap<MiniRpcProvider>;
    protected _web3Providers: ChainIdTypeMap<Web3Provider>;
    protected _chainEndpoints: {
        [chainId: number]: string;
    };
    constructor(args: RpcConnectorArgs);
    provider(chainId: number): Provider;
    private _newProvider;
}
export {};
